# 24/03/2011 SJH_GettingStarted_v02.rb

# Master Copy location: C:/SJHCode/Ruby187/SU_Ruby/SJH_GettingStarted(_version).rb
# Run location: you choose how you want to use this file, see below!

# Sketchup Ruby API - Getting Started

# Copyright SJH 2011
# Credits and many, many Thanks for Getting me Started! to:
# All at Google Sketchup and everyone on the forums.
# All at Ruby and everyone on the forums.
# All at Notepad++
# All at Sketchup Bridge, TBD?!
# All at SketchUcation and everyone on the forums, excellent work Gaieus
# (I finally managed to register on 22/03/2011, I have issues with the GFW of CN!)

# Special thanks to:

# Dan Rathbun
# Forum topic: Ruby Newbie's Guide to Getting Started
# http://forums.sketchucation.com/viewtopic.php?f=180&t=10142&start=15#p298780
# !!! If only I found this two weeks ago, invaluable !!!
# Fortunately I'd already done most of the things on the list
#  and I haven't posted a question yet, although I have dozens!
#  3.times{puts("Search, read, try, try and try again!")}  ;)

# TIG
# Forum topic: How do I make my 3D shapes a specific color? Options 
# http://groups.google.com/group/sketchupruby/browse_thread/thread/5af5ad98287b22ec/a15158c2360a352c?lnk=gst&q=iterate+through+groups#a15158c2360a352c
# After some mining in this post, I found; The Basic concepts, it would be great if this explination was extracted from here and posted in it's own article.
# Dan's also got good stuff in there which could make a useful Tutorial...

# I'd love to see some diagrams, similar to the SU API map but better and complete! ;) showing visualy what's going on with SU Ruby method/s. 
# I haven't come accross any yet.  Do any exist?  I've seen links to Tut videos but they're blocked here... :(
# For a Newbie the words/methods are (almost) over whelmingly similar!  I imagine that's fine once you (really) know, what you're doing...

# What's 'context/active/model/entities???!' this that and the other... all I understand at the moment, is that they are very important!  And beware of Groups?!
# A diagram or three! would make visualizing the processes easier.
# For example there could be a graphic of boxes representing the computers memory(?)
#  where the code is stored, where the variables are stored, collections and other containers(??) all indicative of course, we don't want memory addresses!!
# I then picture seeing screen shots of the SU 3D window with the 'real things' displayed and a graphic relating to their code counter parts(???)

# Simple flow charts or something??? I'm not sure exactly 'what' diagrams because I still don't fully understand the processes... otherwise I'd try making my own...
#  or maybe I'm just nuts AND have demonstrated I really am NOT worthy and haven't got a clue what I'm on about!  ;)
# Anyway, Thanks for all your excellent posts.  :)  And I'm not suggesting for one momment YOU produce the diagrams!

# More special thanks to:
# Chris Fullmer, thomthom, Jim, cjthompson, MartinRinehart

# Forum topic: Quickly finding groups/comps in an Entity Collection?
# http://www.sketchucation.com/forums/viewtopic.php?f=180&t=27821&sid=98a241add265ce29f9db7f5a50bdf22b
# Forum topic: function to acess groups or components 
# http://groups.google.com/group/sketchupruby/browse_thread/thread/f0f17e781ae53606/e54da96adfff00bf?lnk=gst&q=iterate+through+groups#e54da96adfff00bf

# The whole nested groups thing was driving me nuts and still makes me Dizzy!
# Until a few days ago I'd never heard of a recursive iteration function!!!  Ouch!

# The above posts have really helped, thank you, I've learnt soooo much,.. but I'm still not worthy! ;)
# The bottom line is, at the risk of sounding like Ronald McDonald, "I'm lovin' it!!!   :)


# Books used so far:
# Chris Pine - Learn To Program-2nd Edition (IMHO, a must have for non-programers)
# Martin Rinehart - Edges to Rubies (informative, interesting and best of all, good FUN!)
# Why's? - Poignant guide To Ruby  (and I thought I was... hmmm... different!)  ;)
# http://www.techotopia.com/index.php/Ruby_Essentials (an excellent overview)



# I guess this should be said everytime:
#-----------------------------------------------------------------------------
# This software is provided as an example of using the Ruby interface
# to SketchUp.

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notices and credits appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

# Sketchup Ruby API - Getting Started (What I've learnt so far...)


# Setup Notepad++ and SU Bridge.
# Access Collections and see what's what.
# Take control with basic methods.

# Assumptions: SU, Ruby and Notepad++ are installed.
# You have downloaded the other required files...

# NppExecute plugin installation:
# Put folder NppExec and file NppExec.dll in C:\Program Files\Notepad++\plugins

# SU Bridge installation:
# Put file SUB.exe in C:\Windows\System32
# Put files Bridge.so and bridge_load.rb in C:\Program Files\Google\Google SketchUp 8\Plugins

# With Notepad++ running, (only do the next part once!)
#   Press F6 for execute diag, Type a new command: sub $(FULL_CURRENT_PATH) Save as SendToSU  
#   Ctrl+F6, to run last execute command, What a time saver!



# Now you're ready to Ruby!
# Relax, breath easy and enjoy...

# Note: The commented out items below are tested on SU Pro v8 (Windows Vista)
#       (Unless noted otherwise!)

# Usage of this file:
#   Copy/paste code directly to SU console or
#   remove/add comments as required and save.
#   To run as a script :
#   load 'C:/SJHCode/Ruby187/SU_Ruby/SJH_GettingStarted(_version).rb'
# Note: Replace my file path and file name with your own!

# or (this is my currently prefered method)

#   From Notepad++
#   Ctrl+F6, to run last execute command, !!! What a time saver!!!


# Block comment using: =begin  =end
=begin
bla, bla, bla
bla, bla, bla
# Single line comments must be obvious by now!
bla, bla, bla 
bla, bla, bla
=end


# Sketchup.send_action "showRubyPanel:" # Show the Ruby Console

# If you followed Martins example this shouldn't be required by now,
# I have my own SJH_SU_Start.rb file!

# Add a Menu to Plugins menu
# UI.menu("PlugIns").add_item("SJH Testing") {UI.messagebox("Are you ready?!")}


require 'sketchup.rb' # ALWAYS required!

model = Sketchup.active_model  # Grab the active SU model (ALWAYS required!)
                               # Note: Mac users could have more than 1 model open!
							   
# Grab other handles to commonly used Collections inside the model.
entities = model.entities    # Grab a handle to the models entities Collection
layers = model.layers        # Grab a handle to the models layers Collection
materials = model.materials  # Grab a handle to the models materials Collection
component_definitions = model.definitions  # Grab a handle to the models Component Definitions Collection
selection = model.selection  # Grab a handle to the models selection Collection


# Check that the active model is loaded ok.
if (! model)
  UI.messagebox("Warning: No model loaded!")  # User message
else
  puts("Active model loaded OK. Object ID: #{model.object_id}")  # Console message
#  UI.messagebox("Active model loaded OK.\n" + "Object: #{model}")
  end


# Use the .clear method to clear any selections, it's this easy!
  selection.clear              # Clear any Selections
  puts("\n Selection clear.") # Console message, \n creates an empty newline

# String substitutions:
# Use single quotes ' ' or double quotes " " - double quotes allow more flexibility
# '\'' - single quote (apostraphe)
# '\\' - backslash

# "\'" - single quote
# "\"" - double quote
# "\a" - bell (alert)
# "\b" - backslash
# "\n" - newline
# "\r" - return
# "\s" - space
# "\t" - tab



# The basics:
  
=begin 
# Grab handles to the model Collections (see above).  This is always done!
# You've basically created arrays for each Collection type object.
# We now have access to the active models entities, so type:
 
  entities.length
 
# This will return the number of (drawingelement) enities in the model.
# Note: NOT including nested entities in Group or Component objects!
# We now know how many entities we have but what are they?
# To find this out we need to know how to look inside the entities array. 
# Remember, entities=model.entities, which is all the entities in the model. To start with
# let's look at the first one, position 0 in the array, entities[0].

  entities[0].class  # The object class at position 0 (the first entity)

  entities[1].class  # The object class at position 1 (the second entity)

  entities[2].class  # The object class at position 2 (the third entity)
=end 

# We now know what the entities are, so let's select them:
 
=begin
# Add entities to a selection one at a time (Painful!)

  puts("New selection.") # Console message
  
  entity = entities[0]       #Setup the argument value (0, the first) for the add method
  selection.add(entity)      #Use the .add method to add to the selection

   entity = entities[1]      #Setup the argument value (1, the second) for the add method
  selection.add(entity)      #Use the .add method to add to the selection
 
  entity = entities[2]       #Setup the argument value (2, the third) for the add method
  selection.add(entity)      #Use the .add method to add to the selection
=end

# Selected entities should be visible on the screen, amazing, we're doing something already!
# Let's speed things up a bit by selecting all!

=begin
# Find all model entities and put them in a selection by
# using the .each method to step through all the objects

  puts("New selection.") # Console message
  
  entities.each { |entobjects| selection.add(entobjects) }  # Popular method to select all,
                                                            # but can be slow!

# Faster selection method
# ents = []
# model.entities.each { |e| ents << e}
# model.selection.add(ents)

# Another way to add all to selection
# model.selection.add(model.entities.to_a)  # This is fast and easy to read/understand
=end

# Now we're flying!
# Let's give the user some feed back:

=begin  
# Display each type of entity selected in a User(Interface) message box

   selection.each { |entobjects| UI.messagebox("Entity class: #{entobjects.class}") }

   # Note: Do not use with too many entities selected, the User will go crazy!

# It's better to list them in the console

  selection.each { |entobjects| puts("Entity class: #{entobjects.class}") }  # Console message

# Now we can quickly find an object's class, very useful...
# You can also substitute .class for .typename in the above line of code.

# Note: When searching for objects it is quicker to search by .class rather than .typename
# Generally string manipulation is slower than object manipulation.

# Useful entity classes;  (See SU API Class map for more).

# Sketchup::Edge, Sketchup::Face 
  Sketchup::Group, Sketchup::ComponentInstance
  Sketchup::ComponentDefinition
  
# How many entities in the selection?
# Note: again, NOT counting nested objects.

  numitems = selection.nitems  #Use the .nitems method to return the number of selected items 

  puts("There are #{numitems} items selected.")  # Console message
  UI.messagebox("There are #{numitems} items selected.")  # User message
=end

# Now we're starting to take control!
# Let's get some of these methods working together.

=begin
# To select Group objects only:
# Use the .each method to step through all the model entities (iterate)
# and add them to a selection only IF the object .is_a? Sketchup::Group

  selection.clear              # Clear any Selections 
 
  entities.each { |entobjects| selection.add(entobjects) if( entobjects.is_a? Sketchup::Group ) }
  
  numitems = selection.nitems  # Return the number of selected items 
  puts("There are #{numitems} Group objects selected.")  # Console message
  UI.messagebox("There are #{numitems} Group objects selected.")  # User message
  
# List the selected Group object names
    selection.each { |entobjects| puts("Group name: #{entobjects.name}") }  # Console message

#  UI.messagebox("Click OK to clear selection.")  # User message
#  selection.clear              # Clear any Selections
#  puts("Selection clear.")    # Console message 

# Exploding Group selections is easy!

  ent=selection[0]
   puts("About to EXPLODE Groups!")  # Console message
   UI.messagebox("About to EXPLODE Groups!")  # User message	
   ent.explode
   UI.messagebox("!!!Groups EXPLODED!!!")  # User message
=end 

# OK, let's calm down and look at another Collection class; materials: 
 
=begin 
# Show the total number of Materials in the model and their names
# Use the method material.name for Code/Console and material.display_name for User messages

  number_materials = materials.length # Get the total number of materials

  puts("There are #{number_materials} Material types in the Model.") # Console message
  UI.messagebox("There are #{number_materials} Material types in the Model.")  # User message

  names = materials.collect {|m| m.name + ", "} # Collect the material names
  
  displaynames = materials.collect {|m| m.display_name + ", "}
  displaynames = (displaynames.to_s)
  
  puts("Materials by name are:") # Console message
  puts(materials.collect {|m| m.name}) # Console message
  UI.messagebox("Material names: #{displaynames}")  # User message

# Another way to do the above is to use the .each method
# materials.each{|numitems| UI.messagebox numitems.name} # Drive the User crazy!
=end


# Find and select faces by material type:
# Code taken from SU - examples\examplescripts.rb
# Copyright 2005-2008, Google, Inc.  Modified by SJH 2011

#     Notes on usage:
# !!! The material will only be found if it is on the FRONT Face.
# !!! By default a SU rectangle's front face is down (if looking from Top view).
# !!! The material will NOT be found if it is on a face inside a group.
# !!! The material WILL be found if it is applied 'externally' to a group,
# !!!   but the faces will NOT be included in the selection.

# The User chooses a material type via an inputbox dialog:

def do_select

    model = Sketchup.active_model

    # First clear the selection
    ss = model.selection
    ss.clear
    
    # iterate through everything in the model
    for ent in model.entities
        if( yield(ent) )
            ss.add(ent)
        end
    end
    
    # return the number of things selected
    ss.length
end

def select_by_material
    # First get a list of all of the materials in the model
    model = Sketchup.active_model
    materials = model.materials
    names = materials.collect {|m| m.name}
    displaynames = materials.collect {|m| m.display_name}
    
    # Display a dialog to pick the material to select
    prompts = [$exStrings.GetString("Area Material")]
    values = [displaynames[0]]
    enums = [displaynames.join("|")]
    results = inputbox prompts, values, enums, $exStrings.GetString("Select By Material")
    return if not results
    
    # Now select everything with the selected Material
    index = displaynames.index(results[0])
    materialname = index ? names[index] : $exStrings.GetString("Default")
    do_select {|e| e.material && (e.material.name == materialname)}
end

select_by_material

# Note to self: SU model units appear to be in Inches?!!!
#               Need to look into this further.

# Display the total area in m2 of the selected material type 
  area = 0 # Reset the area value to zero
  conversion = 25.4*25.4/1000000 # Convert sq inches to sq metres
  matselection = selection[0]    # Make a note of the material selected
  matname = matselection.material.display_name # Get the seleted materials name
  
  selection.each { |ent| area += ent.area if( ent.is_a? Sketchup::Face ) }

  puts("\nThe total area of: #{matname}") # Console message 
  puts("Is: #{(area*conversion)} m2")     # Console message
  UI.messagebox("The total area of: #{matname}  Is: #{(area*conversion)} m2")  # User message

  
  
  UI.messagebox("What's next?")

 
=begin
# NOT TESTED
# compute the total area of all faces
def totalArea
area = 0
model = Sketchup.active_model
# this shows a different syntax for iterating through the model
model.entities.each { |ent| area += ent.area if( ent.is_a? Sketchup::Face ) }
#
#
#
#
#
# here is a different way you could do it
for ent in model.entities
if( ent.is_a? Sketchup::Face )
area += ent.area
end
end
area
end
#-------------------------------------------------------------------------
# Get the perimeter of the selected faces
def perimeter
length = 0
edges = []
# First collect all of the edges that bound all of the selected faces.
model = Sketchup.active_model
ss = model.selection
for ent in ss
if( ent.is_a? Sketchup::Face )
edges.concat ent.edges
end
end
# remove duplicate edges
edges.uniq!
# sum the lengths of all of the edges
edges.each {|e| length += e.length}
length
end

# SJH Note to self
# Now do ALL the above with nested entities...
# Get a drink BEFORE you're too Dizzy to do so!
=end



# end of SJH_GettingStart(_version).rb
